/*
   Gspoof v. 2.1 - interface.c
                                    */

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "common.h"

GtkWidget*
  create_mainwin (void)
{
   GtkWidget *mainwin;
   GtkWidget *vbox1;
   GtkWidget *OPTION_BOX;
   GtkWidget *ETH_OPTIONS_BOX;
   GtkWidget *ETH_LABEL;
   GtkWidget *ETC_INTERF_BOX;
   GtkWidget *eth_interf_lab;
   GtkWidget *ETH_SRC_BOX;
   GtkWidget *eth_src_lab;
   GtkWidget *ETH_DST_BOX;
   GtkWidget *eth_dst_lab;
   GtkWidget *ETH_TYPE_BOX;
   GtkWidget *eth_type_lab;
   GtkWidget *ETH_TYPE_COMBO;
   GtkWidget *IP_OPTIONS_BOX;
   GtkWidget *IP_LABEL;
   GtkWidget *IP_SRC_BOX;
   GtkWidget *ip_src_lab;
   GtkWidget *IP_DST_BOX;
   GtkWidget *ip_dst_lab;
   GtkWidget *IP_TTL_BOX;
   GtkWidget *ip_ttl_lab;
   GtkWidget *IP_ID_BOX;
   GtkWidget *ip_id_lab;
   GtkWidget *IP_TOS_BOX;
   GtkWidget *ip_tos_lab;
   GtkWidget *TCP_OPTIONS_BOX;
   GtkWidget *TCP_LABEL;
   GtkWidget *TCP_SRC_PORT;
   GtkWidget *tcp_src_lab;
   GtkWidget *TCP_DST_PORT;
   GtkWidget *tcp_dst_lab;
   GtkWidget *TCP_FLAG_BOX;
   GtkWidget *tcp_flag_lab;
   GtkWidget *FLAG_BOX_H;
   GtkWidget *FLAG_BOX_V1;
   GtkWidget *FLAG_BOX_V2;
   GtkWidget *TCP_SEQ_BOX;
   GtkWidget *tcp_seq_lab;
   GtkWidget *TCP_ACk_BOX;
   GtkWidget *tcp_ack_lab;
   GtkWidget *TCP_WIN_BOX;
   GtkWidget *tcp_win_lab;
   GtkWidget *TCP_URG_BOX;
   GtkWidget *tcp_urg_lab;
   GtkWidget *DATABOX;
   GtkWidget *DATACONTROL;
   GtkWidget *CONTROLBOX;
   GtkWidget *vbox4;
   GtkWidget *SENDBUT;
   GtkWidget *RESETBUT;
   GtkWidget *vbox6;
   GtkWidget *togglebutton1;
   GtkWidget *hbox6;
   GtkWidget *CREDIT_BUTTON;
   GtkWidget *QUIT_BUTTON;
   GtkWidget *vbox3;
   GtkWidget *MULTIPKG;
   GtkWidget *hbox5;
   GtkWidget *DELAYLABEL;
   GtkWidget *INFOWIN;
   GList *ETH_TYPE_COMBO_items = NULL;

   /* */
   
   mainwin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   gtk_object_set_data (GTK_OBJECT (mainwin), "mainwin", mainwin);
   gtk_widget_set_usize (mainwin, 640, 480);
   gtk_container_set_border_width (GTK_CONTAINER (mainwin), 5);
   gtk_window_set_title (GTK_WINDOW (mainwin), BANNER);
   gtk_window_set_position (GTK_WINDOW (mainwin), GTK_WIN_POS_CENTER);

   vbox1 = gtk_vbox_new (FALSE, 0);
   gtk_widget_ref (vbox1);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "vbox1", vbox1,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (vbox1);
   gtk_container_add (GTK_CONTAINER (mainwin), vbox1);

   OPTION_BOX = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (OPTION_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "OPTION_BOX", OPTION_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (OPTION_BOX);
   gtk_box_pack_start (GTK_BOX (vbox1), OPTION_BOX, TRUE, TRUE, 0);
   gtk_container_set_border_width (GTK_CONTAINER (OPTION_BOX), 2);

   ETH_OPTIONS_BOX = gtk_vbox_new (FALSE, 0);
   gtk_widget_ref (ETH_OPTIONS_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ETH_OPTIONS_BOX", ETH_OPTIONS_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ETH_OPTIONS_BOX);
   gtk_box_pack_start (GTK_BOX (OPTION_BOX), ETH_OPTIONS_BOX, TRUE, TRUE, 0);
   gtk_widget_set_usize (ETH_OPTIONS_BOX, 230, -2);
   gtk_container_set_border_width (GTK_CONTAINER (ETH_OPTIONS_BOX), 5);

   ETH_LABEL = gtk_label_new ("ETHERNET OPTIONS (Link Layer)");
   gtk_widget_ref (ETH_LABEL);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ETH_LABEL", ETH_LABEL,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ETH_LABEL);
   gtk_box_pack_start (GTK_BOX (ETH_OPTIONS_BOX), ETH_LABEL, FALSE, FALSE, 0);
   gtk_widget_set_usize (ETH_LABEL, -2, 20);

   ETC_INTERF_BOX = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (ETC_INTERF_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ETC_INTERF_BOX", ETC_INTERF_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ETC_INTERF_BOX);
   gtk_box_pack_start (GTK_BOX (ETH_OPTIONS_BOX), ETC_INTERF_BOX, TRUE, TRUE, 0);

   eth_interf_lab = gtk_label_new ("Interface");
   gtk_widget_ref (eth_interf_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "eth_interf_lab", eth_interf_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (eth_interf_lab);
   gtk_box_pack_start (GTK_BOX (ETC_INTERF_BOX), eth_interf_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (eth_interf_lab, 60, -2);

   eth_int_txt = gtk_entry_new ();
   gtk_widget_ref (eth_int_txt);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "eth_int_txt", eth_int_txt,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (eth_int_txt);
   gtk_box_pack_start (GTK_BOX (ETC_INTERF_BOX), eth_int_txt, TRUE, TRUE, 0);
   gtk_entry_set_editable (GTK_ENTRY (eth_int_txt), FALSE);

   ETH_SRC_BOX = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (ETH_SRC_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ETH_SRC_BOX", ETH_SRC_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ETH_SRC_BOX);
   gtk_box_pack_start (GTK_BOX (ETH_OPTIONS_BOX), ETH_SRC_BOX, TRUE, TRUE, 0);

   eth_src_lab = gtk_label_new ("Src MAC");
   gtk_widget_ref (eth_src_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "eth_src_lab", eth_src_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (eth_src_lab);
   gtk_box_pack_start (GTK_BOX (ETH_SRC_BOX), eth_src_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (eth_src_lab, 60, -2);

   eth_src_txt = gtk_entry_new_with_max_length (17);
   gtk_widget_ref (eth_src_txt);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "eth_src_txt", eth_src_txt,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (eth_src_txt);
   gtk_box_pack_start (GTK_BOX (ETH_SRC_BOX), eth_src_txt, TRUE, TRUE, 0);
   gtk_entry_set_editable (GTK_ENTRY (eth_src_txt), FALSE);

   ETH_DST_BOX = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (ETH_DST_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ETH_DST_BOX", ETH_DST_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ETH_DST_BOX);
   gtk_box_pack_start (GTK_BOX (ETH_OPTIONS_BOX), ETH_DST_BOX, TRUE, TRUE, 0);

   eth_dst_lab = gtk_label_new ("Dst MAC");
   gtk_widget_ref (eth_dst_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "eth_dst_lab", eth_dst_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (eth_dst_lab);
   gtk_box_pack_start (GTK_BOX (ETH_DST_BOX), eth_dst_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (eth_dst_lab, 60, -2);

   eth_dst_txt = gtk_entry_new_with_max_length (17);
   gtk_widget_ref (eth_dst_txt);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "eth_dst_txt", eth_dst_txt,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (eth_dst_txt);
   gtk_box_pack_start (GTK_BOX (ETH_DST_BOX), eth_dst_txt, TRUE, TRUE, 0);
   gtk_entry_set_editable (GTK_ENTRY (eth_dst_txt), FALSE);

   ETH_TYPE_BOX = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (ETH_TYPE_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ETH_TYPE_BOX", ETH_TYPE_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ETH_TYPE_BOX);
   gtk_box_pack_start (GTK_BOX (ETH_OPTIONS_BOX), ETH_TYPE_BOX, TRUE, TRUE, 0);

   eth_type_lab = gtk_label_new ("ETH Type");
   gtk_widget_ref (eth_type_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "eth_type_lab", eth_type_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (eth_type_lab);
   gtk_box_pack_start (GTK_BOX (ETH_TYPE_BOX), eth_type_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (eth_type_lab, 60, -2);

   ETH_TYPE_COMBO = gtk_combo_new ();
   gtk_widget_ref (ETH_TYPE_COMBO);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ETH_TYPE_COMBO", ETH_TYPE_COMBO,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ETH_TYPE_COMBO);
   gtk_box_pack_start (GTK_BOX (ETH_TYPE_BOX), ETH_TYPE_COMBO, TRUE, TRUE, 0);
   ETH_TYPE_COMBO_items = g_list_append (ETH_TYPE_COMBO_items, (gpointer) "IP");
   ETH_TYPE_COMBO_items = g_list_append (ETH_TYPE_COMBO_items, (gpointer) "loopback");
   gtk_combo_set_popdown_strings (GTK_COMBO (ETH_TYPE_COMBO), ETH_TYPE_COMBO_items);
   g_list_free (ETH_TYPE_COMBO_items);

   combo_entry1 = GTK_COMBO (ETH_TYPE_COMBO)->entry;
   gtk_widget_ref (combo_entry1);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "combo_entry1", combo_entry1,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (combo_entry1);
   gtk_entry_set_text (GTK_ENTRY (combo_entry1), "IP");

   IP_OPTIONS_BOX = gtk_vbox_new (FALSE, 0);
   gtk_widget_ref (IP_OPTIONS_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "IP_OPTIONS_BOX", IP_OPTIONS_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (IP_OPTIONS_BOX);
   gtk_box_pack_start (GTK_BOX (OPTION_BOX), IP_OPTIONS_BOX, TRUE, TRUE, 0);
   gtk_widget_set_usize (IP_OPTIONS_BOX, 230, -2);
   gtk_container_set_border_width (GTK_CONTAINER (IP_OPTIONS_BOX), 5);

   IP_LABEL = gtk_label_new ("IP OPTIONS (Network Layer)");
   gtk_widget_ref (IP_LABEL);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "IP_LABEL", IP_LABEL,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (IP_LABEL);
   gtk_box_pack_start (GTK_BOX (IP_OPTIONS_BOX), IP_LABEL, FALSE, FALSE, 0);
   gtk_widget_set_usize (IP_LABEL, -2, 24);
   gtk_misc_set_alignment (GTK_MISC (IP_LABEL), 0.5, 0.16);

   IP_SRC_BOX = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (IP_SRC_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "IP_SRC_BOX", IP_SRC_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (IP_SRC_BOX);
   gtk_box_pack_start (GTK_BOX (IP_OPTIONS_BOX), IP_SRC_BOX, TRUE, TRUE, 0);

   ip_src_lab = gtk_label_new ("Src addr");
   gtk_widget_ref (ip_src_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ip_src_lab", ip_src_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ip_src_lab);
   gtk_box_pack_start (GTK_BOX (IP_SRC_BOX), ip_src_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (ip_src_lab, 60, -2);

   ip_src_txt = gtk_entry_new_with_max_length (30);
   gtk_widget_ref (ip_src_txt);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ip_src_txt", ip_src_txt,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ip_src_txt);
   gtk_box_pack_start (GTK_BOX (IP_SRC_BOX), ip_src_txt, TRUE, TRUE, 0);

   IP_DST_BOX = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (IP_DST_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "IP_DST_BOX", IP_DST_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (IP_DST_BOX);
   gtk_box_pack_start (GTK_BOX (IP_OPTIONS_BOX), IP_DST_BOX, FALSE, FALSE, 0);

   ip_dst_lab = gtk_label_new ("Dst addr");
   gtk_widget_ref (ip_dst_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ip_dst_lab", ip_dst_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ip_dst_lab);
   gtk_box_pack_start (GTK_BOX (IP_DST_BOX), ip_dst_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (ip_dst_lab, 60, 58);

   ip_dst_txt = gtk_entry_new_with_max_length (30);
   gtk_widget_ref (ip_dst_txt);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ip_dst_txt", ip_dst_txt,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ip_dst_txt);
   gtk_box_pack_start (GTK_BOX (IP_DST_BOX), ip_dst_txt, TRUE, TRUE, 0);

   IP_TTL_BOX = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (IP_TTL_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "IP_TTL_BOX", IP_TTL_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (IP_TTL_BOX);
   gtk_box_pack_start (GTK_BOX (IP_OPTIONS_BOX), IP_TTL_BOX, TRUE, TRUE, 0);

   ip_ttl_lab = gtk_label_new ("TTL");
   gtk_widget_ref (ip_ttl_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ip_ttl_lab", ip_ttl_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ip_ttl_lab);
   gtk_box_pack_start (GTK_BOX (IP_TTL_BOX), ip_ttl_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (ip_ttl_lab, 60, -2);

   ip_ttl_txt = gtk_entry_new_with_max_length (3);
   gtk_widget_ref (ip_ttl_txt);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ip_ttl_txt", ip_ttl_txt,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ip_ttl_txt);
   gtk_box_pack_start (GTK_BOX (IP_TTL_BOX), ip_ttl_txt, TRUE, TRUE, 0);
   gtk_entry_set_text (GTK_ENTRY (ip_ttl_txt), "64");

   IP_ID_BOX = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (IP_ID_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "IP_ID_BOX", IP_ID_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (IP_ID_BOX);
   gtk_box_pack_start (GTK_BOX (IP_OPTIONS_BOX), IP_ID_BOX, TRUE, TRUE, 0);

   ip_id_lab = gtk_label_new ("ID");
   gtk_widget_ref (ip_id_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ip_id_lab", ip_id_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ip_id_lab);
   gtk_box_pack_start (GTK_BOX (IP_ID_BOX), ip_id_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (ip_id_lab, 60, -2);

   ip_id_txt = gtk_entry_new_with_max_length (5);
   gtk_widget_ref (ip_id_txt);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ip_id_txt", ip_id_txt,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ip_id_txt);
   gtk_box_pack_start (GTK_BOX (IP_ID_BOX), ip_id_txt, TRUE, TRUE, 0);

   IP_TOS_BOX = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (IP_TOS_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "IP_TOS_BOX", IP_TOS_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (IP_TOS_BOX);
   gtk_box_pack_start (GTK_BOX (IP_OPTIONS_BOX), IP_TOS_BOX, TRUE, TRUE, 0);

   ip_tos_lab = gtk_label_new ("TOS");
   gtk_widget_ref (ip_tos_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ip_tos_lab", ip_tos_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ip_tos_lab);
   gtk_box_pack_start (GTK_BOX (IP_TOS_BOX), ip_tos_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (ip_tos_lab, 60, -2);

   ip_tos_txt = gtk_entry_new_with_max_length (3);
   gtk_widget_ref (ip_tos_txt);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ip_tos_txt", ip_tos_txt,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ip_tos_txt);
   gtk_box_pack_start (GTK_BOX (IP_TOS_BOX), ip_tos_txt, TRUE, TRUE, 0);
   gtk_entry_set_text (GTK_ENTRY (ip_tos_txt), "8");

   TCP_OPTIONS_BOX = gtk_vbox_new (FALSE, 0);
   gtk_widget_ref (TCP_OPTIONS_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "TCP_OPTIONS_BOX", TCP_OPTIONS_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (TCP_OPTIONS_BOX);
   gtk_box_pack_start (GTK_BOX (OPTION_BOX), TCP_OPTIONS_BOX, TRUE, TRUE, 0);
   gtk_container_set_border_width (GTK_CONTAINER (TCP_OPTIONS_BOX), 5);

   TCP_LABEL = gtk_label_new ("TCP OPTIONS (Transport Layer)");
   gtk_widget_ref (TCP_LABEL);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "TCP_LABEL", TCP_LABEL,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (TCP_LABEL);
   gtk_box_pack_start (GTK_BOX (TCP_OPTIONS_BOX), TCP_LABEL, FALSE, FALSE, 0);
   gtk_widget_set_usize (TCP_LABEL, -2, 27);
   gtk_misc_set_alignment (GTK_MISC (TCP_LABEL), 0.5, 0.1);

   TCP_SRC_PORT = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (TCP_SRC_PORT);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "TCP_SRC_PORT", TCP_SRC_PORT,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (TCP_SRC_PORT);
   gtk_box_pack_start (GTK_BOX (TCP_OPTIONS_BOX), TCP_SRC_PORT, TRUE, TRUE, 0);

   tcp_src_lab = gtk_label_new ("Src port");
   gtk_widget_ref (tcp_src_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "tcp_src_lab", tcp_src_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (tcp_src_lab);
   gtk_box_pack_start (GTK_BOX (TCP_SRC_PORT), tcp_src_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (tcp_src_lab, 80, -2);
   gtk_misc_set_padding (GTK_MISC (tcp_src_lab), 0, 10);

   tcp_src_txt = gtk_entry_new_with_max_length (5);
   gtk_widget_ref (tcp_src_txt);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "tcp_src_txt", tcp_src_txt,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (tcp_src_txt);
   gtk_box_pack_start (GTK_BOX (TCP_SRC_PORT), tcp_src_txt, TRUE, TRUE, 0);

   TCP_DST_PORT = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (TCP_DST_PORT);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "TCP_DST_PORT", TCP_DST_PORT,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (TCP_DST_PORT);
   gtk_box_pack_start (GTK_BOX (TCP_OPTIONS_BOX), TCP_DST_PORT, TRUE, TRUE, 0);

   tcp_dst_lab = gtk_label_new ("Dst port");
   gtk_widget_ref (tcp_dst_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "tcp_dst_lab", tcp_dst_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (tcp_dst_lab);
   gtk_box_pack_start (GTK_BOX (TCP_DST_PORT), tcp_dst_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (tcp_dst_lab, 80, -2);
   gtk_misc_set_padding (GTK_MISC (tcp_dst_lab), 0, 10);

   tcp_dst_txt = gtk_entry_new_with_max_length (5);
   gtk_widget_ref (tcp_dst_txt);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "tcp_dst_txt", tcp_dst_txt,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (tcp_dst_txt);
   gtk_box_pack_start (GTK_BOX (TCP_DST_PORT), tcp_dst_txt, TRUE, TRUE, 0);

   TCP_FLAG_BOX = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (TCP_FLAG_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "TCP_FLAG_BOX", TCP_FLAG_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (TCP_FLAG_BOX);
   gtk_box_pack_start (GTK_BOX (TCP_OPTIONS_BOX), TCP_FLAG_BOX, TRUE, TRUE, 0);

   tcp_flag_lab = gtk_label_new ("FLAGS");
   gtk_widget_ref (tcp_flag_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "tcp_flag_lab", tcp_flag_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (tcp_flag_lab);
   gtk_box_pack_start (GTK_BOX (TCP_FLAG_BOX), tcp_flag_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (tcp_flag_lab, 80, -2);
   gtk_misc_set_padding (GTK_MISC (tcp_flag_lab), 0, 10);

   FLAG_BOX_H = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (FLAG_BOX_H);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "FLAG_BOX_H", FLAG_BOX_H,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (FLAG_BOX_H);
   gtk_box_pack_start (GTK_BOX (TCP_FLAG_BOX), FLAG_BOX_H, TRUE, TRUE, 0);

   FLAG_BOX_V1 = gtk_vbox_new (TRUE, 0);
   gtk_widget_ref (FLAG_BOX_V1);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "FLAG_BOX_V1", FLAG_BOX_V1,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (FLAG_BOX_V1);
   gtk_box_pack_start (GTK_BOX (FLAG_BOX_H), FLAG_BOX_V1, TRUE, TRUE, 0);

   URGCHECK = gtk_check_button_new_with_label ("URG");
   gtk_widget_ref (URGCHECK);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "URGCHECK", URGCHECK,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (URGCHECK);
   gtk_box_pack_start (GTK_BOX (FLAG_BOX_V1), URGCHECK, FALSE, FALSE, 0);

   ACKCHECK = gtk_check_button_new_with_label ("ACK");
   gtk_widget_ref (ACKCHECK);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "ACKCHECK", ACKCHECK,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (ACKCHECK);
   gtk_box_pack_start (GTK_BOX (FLAG_BOX_V1), ACKCHECK, FALSE, FALSE, 0);

   PSHCHECK = gtk_check_button_new_with_label ("PSH");
   gtk_widget_ref (PSHCHECK);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "PSHCHECK", PSHCHECK,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (PSHCHECK);
   gtk_box_pack_start (GTK_BOX (FLAG_BOX_V1), PSHCHECK, FALSE, FALSE, 0);

   FLAG_BOX_V2 = gtk_vbox_new (TRUE, 0);
   gtk_widget_ref (FLAG_BOX_V2);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "FLAG_BOX_V2", FLAG_BOX_V2,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (FLAG_BOX_V2);
   gtk_box_pack_start (GTK_BOX (FLAG_BOX_H), FLAG_BOX_V2, TRUE, TRUE, 0);

   RSTCHECK = gtk_check_button_new_with_label ("RST");
   gtk_widget_ref (RSTCHECK);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "RSTCHECK", RSTCHECK,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (RSTCHECK);
   gtk_box_pack_start (GTK_BOX (FLAG_BOX_V2), RSTCHECK, FALSE, FALSE, 0);

   SYNCHECK = gtk_check_button_new_with_label ("SYN");
   gtk_widget_ref (SYNCHECK);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "SYNCHECK", SYNCHECK,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (SYNCHECK);
   gtk_box_pack_start (GTK_BOX (FLAG_BOX_V2), SYNCHECK, FALSE, FALSE, 0);

   FINCHECK = gtk_check_button_new_with_label ("FIN");
   gtk_widget_ref (FINCHECK);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "FINCHECK", FINCHECK,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (FINCHECK);
   gtk_box_pack_start (GTK_BOX (FLAG_BOX_V2), FINCHECK, FALSE, FALSE, 0);

   TCP_SEQ_BOX = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (TCP_SEQ_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "TCP_SEQ_BOX", TCP_SEQ_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (TCP_SEQ_BOX);
   gtk_box_pack_start (GTK_BOX (TCP_OPTIONS_BOX), TCP_SEQ_BOX, TRUE, TRUE, 0);

   tcp_seq_lab = gtk_label_new ("SEQ number");
   gtk_widget_ref (tcp_seq_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "tcp_seq_lab", tcp_seq_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (tcp_seq_lab);
   gtk_box_pack_start (GTK_BOX (TCP_SEQ_BOX), tcp_seq_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (tcp_seq_lab, 80, -2);
   gtk_misc_set_padding (GTK_MISC (tcp_seq_lab), 0, 10);

   tcp_seq_txt = gtk_entry_new_with_max_length (10);
   gtk_widget_ref (tcp_seq_txt);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "tcp_seq_txt", tcp_seq_txt,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (tcp_seq_txt);
   gtk_box_pack_start (GTK_BOX (TCP_SEQ_BOX), tcp_seq_txt, TRUE, TRUE, 0);

   TCP_ACk_BOX = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (TCP_ACk_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "TCP_ACk_BOX", TCP_ACk_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (TCP_ACk_BOX);
   gtk_box_pack_start (GTK_BOX (TCP_OPTIONS_BOX), TCP_ACk_BOX, TRUE, TRUE, 0);

   tcp_ack_lab = gtk_label_new ("ACK number");
   gtk_widget_ref (tcp_ack_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "tcp_ack_lab", tcp_ack_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (tcp_ack_lab);
   gtk_box_pack_start (GTK_BOX (TCP_ACk_BOX), tcp_ack_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (tcp_ack_lab, 80, -2);
   gtk_misc_set_padding (GTK_MISC (tcp_ack_lab), 0, 10);

   tcp_ack_txt = gtk_entry_new_with_max_length (10);
   gtk_widget_ref (tcp_ack_txt);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "tcp_ack_txt", tcp_ack_txt,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (tcp_ack_txt);
   gtk_box_pack_start (GTK_BOX (TCP_ACk_BOX), tcp_ack_txt, TRUE, TRUE, 0);

   TCP_WIN_BOX = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (TCP_WIN_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "TCP_WIN_BOX", TCP_WIN_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (TCP_WIN_BOX);
   gtk_box_pack_start (GTK_BOX (TCP_OPTIONS_BOX), TCP_WIN_BOX, TRUE, TRUE, 0);

   tcp_win_lab = gtk_label_new ("Window Size");
   gtk_widget_ref (tcp_win_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "tcp_win_lab", tcp_win_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (tcp_win_lab);
   gtk_box_pack_start (GTK_BOX (TCP_WIN_BOX), tcp_win_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (tcp_win_lab, 80, -2);
   gtk_misc_set_padding (GTK_MISC (tcp_win_lab), 0, 10);

   tcp_win_txt = gtk_entry_new_with_max_length (5);
   gtk_widget_ref (tcp_win_txt);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "tcp_win_txt", tcp_win_txt,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (tcp_win_txt);
   gtk_box_pack_start (GTK_BOX (TCP_WIN_BOX), tcp_win_txt, TRUE, TRUE, 0);
   gtk_entry_set_text (GTK_ENTRY (tcp_win_txt), "32767");

   TCP_URG_BOX = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (TCP_URG_BOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "TCP_URG_BOX", TCP_URG_BOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (TCP_URG_BOX);
   gtk_box_pack_start (GTK_BOX (TCP_OPTIONS_BOX), TCP_URG_BOX, TRUE, TRUE, 0);

   tcp_urg_lab = gtk_label_new ("URG Pointer");
   gtk_widget_ref (tcp_urg_lab);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "tcp_urg_lab", tcp_urg_lab,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (tcp_urg_lab);
   gtk_box_pack_start (GTK_BOX (TCP_URG_BOX), tcp_urg_lab, FALSE, FALSE, 0);
   gtk_widget_set_usize (tcp_urg_lab, 80, -2);
   gtk_misc_set_padding (GTK_MISC (tcp_urg_lab), 0, 10);

   tcp_urg_txt = gtk_entry_new_with_max_length (5);
   gtk_widget_ref (tcp_urg_txt);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "tcp_urg_txt", tcp_urg_txt,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (tcp_urg_txt);
   gtk_box_pack_start (GTK_BOX (TCP_URG_BOX), tcp_urg_txt, TRUE, TRUE, 0);

   DATABOX = gtk_vbox_new (TRUE, 0);
   gtk_widget_ref (DATABOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "DATABOX", DATABOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (DATABOX);
   gtk_box_pack_start (GTK_BOX (vbox1), DATABOX, TRUE, TRUE, 0);

   DATACONTROL = gtk_toggle_button_new_with_label ("Inject Data (put a string in TCP payload)");
   gtk_widget_ref (DATACONTROL);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "DATACONTROL", DATACONTROL,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (DATACONTROL);
   gtk_box_pack_start (GTK_BOX (DATABOX), DATACONTROL, FALSE, FALSE, 0);
   gtk_container_set_border_width (GTK_CONTAINER (DATACONTROL), 1);

   DATA = gtk_entry_new_with_max_length (512); /* max 512 byte of data (change here to modify) */
   gtk_widget_ref (DATA);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "DATA", DATA,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (DATA);
   gtk_box_pack_start (GTK_BOX (DATABOX), DATA, FALSE, FALSE, 0);
   gtk_entry_set_editable (GTK_ENTRY (DATA), FALSE);

   CONTROLBOX = gtk_hbox_new (TRUE, 0);
   gtk_widget_ref (CONTROLBOX);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "CONTROLBOX", CONTROLBOX,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (CONTROLBOX);
   gtk_box_pack_start (GTK_BOX (vbox1), CONTROLBOX, FALSE, FALSE, 0);

   vbox4 = gtk_vbox_new (FALSE, 0);
   gtk_widget_ref (vbox4);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "vbox4", vbox4,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (vbox4);
   gtk_box_pack_start (GTK_BOX (CONTROLBOX), vbox4, TRUE, TRUE, 0);

   SENDBUT = gtk_button_new_with_label ("SEND");
   gtk_widget_ref (SENDBUT);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "SENDBUT", SENDBUT,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (SENDBUT);
   gtk_box_pack_start (GTK_BOX (vbox4), SENDBUT, FALSE, FALSE, 0);
   gtk_widget_set_usize (SENDBUT, 200, -2);
   gtk_container_set_border_width (GTK_CONTAINER (SENDBUT), 1);

   RESETBUT = gtk_button_new_with_label ("RESET");
   gtk_widget_ref (RESETBUT);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "RESETBUT", RESETBUT,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (RESETBUT);
   gtk_box_pack_start (GTK_BOX (vbox4), RESETBUT, FALSE, FALSE, 0);
   gtk_container_set_border_width (GTK_CONTAINER (RESETBUT), 1);

   vbox6 = gtk_vbox_new (FALSE, 0);
   gtk_widget_ref (vbox6);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "vbox6", vbox6,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (vbox6);
   gtk_box_pack_start (GTK_BOX (CONTROLBOX), vbox6, FALSE, FALSE, 12);

   togglebutton1 = gtk_toggle_button_new_with_label ("Enable Link-Layer Operations");
   gtk_widget_ref (togglebutton1);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "togglebutton1", togglebutton1,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (togglebutton1);
   gtk_box_pack_start (GTK_BOX (vbox6), togglebutton1, FALSE, FALSE, 0);
   gtk_container_set_border_width (GTK_CONTAINER (togglebutton1), 1);

   hbox6 = gtk_hbox_new (TRUE, 0);
   gtk_widget_ref (hbox6);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "hbox6", hbox6,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (hbox6);
   gtk_box_pack_start (GTK_BOX (vbox6), hbox6, FALSE, FALSE, 0);

   CREDIT_BUTTON = gtk_button_new_with_label ("CREDITS");
   gtk_widget_ref (CREDIT_BUTTON);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "CREDIT_BUTTON", CREDIT_BUTTON,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (CREDIT_BUTTON);
   gtk_box_pack_start (GTK_BOX (hbox6), CREDIT_BUTTON, FALSE, FALSE, 0);
   gtk_widget_set_usize (CREDIT_BUTTON, 86, -2);

   QUIT_BUTTON = gtk_button_new_with_label ("KILLME");
   gtk_widget_ref (QUIT_BUTTON);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "QUIT_BUTTON", QUIT_BUTTON,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (QUIT_BUTTON);
   gtk_box_pack_start (GTK_BOX (hbox6), QUIT_BUTTON, FALSE, FALSE, 0);
   gtk_widget_set_usize (QUIT_BUTTON, 87, -2);

   vbox3 = gtk_vbox_new (FALSE, 0);
   gtk_widget_ref (vbox3);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "vbox3", vbox3,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (vbox3);
   gtk_box_pack_start (GTK_BOX (CONTROLBOX), vbox3, TRUE, TRUE, 0);

   MULTIPKG = gtk_toggle_button_new_with_label ("Send Multi-Packets");
   gtk_widget_ref (MULTIPKG);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "MULTIPKG", MULTIPKG,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (MULTIPKG);
   gtk_box_pack_start (GTK_BOX (vbox3), MULTIPKG, FALSE, FALSE, 0);
   gtk_container_set_border_width (GTK_CONTAINER (MULTIPKG), 1);

   hbox5 = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (hbox5);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "hbox5", hbox5,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (hbox5);
   gtk_box_pack_start (GTK_BOX (vbox3), hbox5, TRUE, TRUE, 0);

   DELAYLABEL = gtk_label_new ("Break(ms) | Lenght(s)");
   gtk_widget_ref (DELAYLABEL);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "DELAYLABEL", DELAYLABEL,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (DELAYLABEL);
   gtk_box_pack_start (GTK_BOX (hbox5), DELAYLABEL, FALSE, FALSE, 0);
   gtk_widget_set_usize (DELAYLABEL, 121, -2);

   DELAY = gtk_entry_new_with_max_length (4); /* u_short */
   gtk_widget_ref (DELAY);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "DELAY", DELAY,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (DELAY);
   gtk_box_pack_start (GTK_BOX (hbox5), DELAY, TRUE, TRUE, 0);
   gtk_entry_set_editable (GTK_ENTRY (DELAY), FALSE);
   gtk_entry_set_text (GTK_ENTRY (DELAY), "100");

   DURATE = gtk_entry_new_with_max_length (4); /* u_short */
   gtk_widget_ref (DURATE);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "DURATE", DURATE,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (DURATE);
   gtk_box_pack_start (GTK_BOX (hbox5), DURATE, TRUE, TRUE, 0);
   gtk_entry_set_editable (GTK_ENTRY (DURATE), FALSE);
   gtk_entry_set_text (GTK_ENTRY (DURATE), "2");

   INFOWIN = gtk_scrolled_window_new (NULL, NULL);
   gtk_widget_ref (INFOWIN);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "INFOWIN", INFOWIN,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (INFOWIN);
   gtk_box_pack_start (GTK_BOX (vbox1), INFOWIN, FALSE, FALSE, 1);
   gtk_widget_set_usize (INFOWIN, -2, 45);
   gtk_container_set_border_width (GTK_CONTAINER (INFOWIN), 1);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (INFOWIN), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

   INFO_TXT = gtk_text_new (NULL, NULL);
   gtk_widget_ref (INFO_TXT);
   gtk_object_set_data_full (GTK_OBJECT (mainwin), "INFO_TXT", INFO_TXT,
			     (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (INFO_TXT);
   gtk_container_add (GTK_CONTAINER (INFOWIN), INFO_TXT);
   gtk_text_insert (GTK_TEXT (INFO_TXT), NULL, NULL, NULL,
		    "\t\t\t\t\t\t\t\t\t-  W E L C O M E    T O    G S P O F F  -\n", -1);

   gtk_signal_connect (GTK_OBJECT (DATACONTROL), "toggled",
		       GTK_SIGNAL_FUNC (on_DATACONTROL_toggled),
		       NULL);
   gtk_signal_connect (GTK_OBJECT (SENDBUT), "clicked",
		       GTK_SIGNAL_FUNC (on_SENDBUT_clicked),
		       NULL);
   gtk_signal_connect (GTK_OBJECT (RESETBUT), "clicked",
		       GTK_SIGNAL_FUNC (on_RESETBUT_clicked),
		       NULL);
   gtk_signal_connect (GTK_OBJECT (togglebutton1), "toggled",
		       GTK_SIGNAL_FUNC (on_togglebutton1_toggled),
		       NULL);
   gtk_signal_connect (GTK_OBJECT (CREDIT_BUTTON), "clicked",
		       GTK_SIGNAL_FUNC (on_CREDIT_BUTTON_clicked),
		       NULL);
   gtk_signal_connect (GTK_OBJECT (QUIT_BUTTON), "clicked",
		       GTK_SIGNAL_FUNC (on_QUIT_BUTTON_clicked),
		       NULL);
   gtk_signal_connect (GTK_OBJECT (MULTIPKG), "toggled",
		       GTK_SIGNAL_FUNC (on_MULTIPKG_toggled),
		       NULL);

   /* flags signals */
   gtk_signal_connect (GTK_OBJECT (URGCHECK), "toggled", GTK_SIGNAL_FUNC (on_URGCHECK_toggled), NULL);
   gtk_signal_connect (GTK_OBJECT (ACKCHECK), "toggled", GTK_SIGNAL_FUNC (on_ACKCHECK_toggled), NULL);
   gtk_signal_connect (GTK_OBJECT (PSHCHECK), "toggled", GTK_SIGNAL_FUNC (on_PSHCHECK_toggled), NULL);
   gtk_signal_connect (GTK_OBJECT (RSTCHECK), "toggled", GTK_SIGNAL_FUNC (on_RSTCHECK_toggled), NULL);
   gtk_signal_connect (GTK_OBJECT (SYNCHECK), "toggled", GTK_SIGNAL_FUNC (on_SYNCHECK_toggled), NULL);
   gtk_signal_connect (GTK_OBJECT (FINCHECK), "toggled", GTK_SIGNAL_FUNC (on_FINCHECK_toggled), NULL);

   /* quit signal */
   gtk_signal_connect (GTK_OBJECT (mainwin), "delete_event", GTK_SIGNAL_FUNC (delete_event), NULL);

   return mainwin;
}

